<?php 
namespace Util;

class KDSLogs {

    public function __construct($logPath, $shouldLog){
        $this->logPath = $logPath;
        $this->file = null;
        $this-> shouldLog = $shouldLog;
    }
    /**
     * Cria um arquivo de log seguindo os parametros passados.
     *
     * @param String  $text  Index de texto no log.
     * @param Object  $obj Objeto que pode ser logado em forma de json.
     * @param String  $path Precisa ser => dirname(__FILE__).'\\'.basename(__FILE__)
     * 
     * @author Bernardo Santos <bernardo.santos@teknisa.com>
     */ 

     public function log($text, $obj, $path){
        if($this-> shouldLog){
            try {

                $date = new \DateTime();
                $fileName = $this-> createFile($path, $date);
                $this->file = fopen($fileName, "a");
                chmod($fileName, 0777);

                $this-> writeOnFile(date_format($date, "Y-m-d H:i:s"));
                $this-> writeOnFile($text);
                $this-> writeOnFile($obj);
                
                fwrite($this->file, "\n");
                fclose($this->file);

            } catch(\Throwable $t) {
                $file = $this->file;
                $e_file = json_encode($file);
                $e_text = json_encode($text);
                $e_obj = json_encode($obj);
                $e_path = json_encode($path);
                $e_t = json_encode($t);
                $error = "file: $e_file, text: $e_text, obj: $e_obj, path: $e_path, t: $e_t";
                var_dump ($error);
                throw new \Exception ($error, 1);
                echo $error;
            }
        }
    }

    private function createFile ($dir, $date) {
        $formatedDate = date_format($date, 'Y-m-d');
        $fileName = str_replace(":", "", $dir);
        $fileName = str_replace("\\", "-", $fileName);
        $fileName = str_replace(".", "-", $fileName);
        $fileName = $fileName."_".$formatedDate;
        
        $this-> zipOlderFiles($this->logPath, $fileName);

        return $this->logPath.$fileName.'.txt';
    }

    private function zipOlderFiles ($dir, $name) {
        $zipMan = new \ZipArchive();
        $files = array_diff(scandir($dir), array('.', '..'));
        
        foreach ($files as $key => $file) {

            $pieces = explode(".", $file);

            $fileName = $pieces[0];
            $fileFormat = $pieces[1];

            if($fileFormat == 'txt' && $fileName != $name){

                $filepath = $dir . $file;
                @chmod($filepath, 0777);

                $zippedFilePath = $dir . $fileName . '.zip';

                $zipMan->open($zippedFilePath, $zipMan::CREATE);
                $zipMan->addFile($filepath, $file);
                $zipMan->close();
                @unlink($filepath);
            }
        }
    }
    
    private function writeOnFile ($text){
        if(isset($text) && strlen(json_encode($text)) > 0) {
            // PHP_EOL: End Of Line
            fwrite($this->file, json_encode($text) . PHP_EOL);
        }
    }

    //utime   |   stime
    public function rutime($ru, $rus, $index = 'utime') {
        $diff = ($ru["ru_$index.tv_sec"]*1000 + intval($ru["ru_$index.tv_usec"]/1000))
         -  ($rus["ru_$index.tv_sec"]*1000 + intval($rus["ru_$index.tv_usec"]/1000));

        return $diff * 1000;
    }
  
}