describe("WizardEngine", function() {
	var localStorageEngine, requestDataSourceEngine, SQLStorageStrategy, restEngine = null;
	var wizardBeforeNextStage = null;
	var wizardOnCancel1 = null;
	var wizardOnCancel2 = null;
	var wizardOnFinishNews = null;
	var wizardOnFinishEnd = null;
	var testDecision = null;
	var wizard1 = (function() {
		return {
			"id": 1234,
			"name": "signUpWizard",
			"label": "Sign Up",
			"type": "wizard",
			"currentStageName": "registerInit",
			"events": [{
				"name": "WizardOnCancel",
				"code": "wizardOnCancel1 = true;",
				"id": 2
			}],
			"history": [],
			"stages": {
				"registerInit": {
					"name": "registerInit",
					"window": "registerInit",
					"events": [{
						"id": 1,
						"name": "WizardBeforeNextStage",
						"code": "wizardBeforeNextStage = true;"
					}, {
						"name": "WizardOnCancel",
						"code": "wizardOnCancel2 = true;",
						"id": 2
					}],
					"nextStages": [{
						"name": "registerAddress",
						"route": "registerAddress"
					}]
				},
				"registerAddress": {
					"name": "registerAddress",
					"window": "registerAddress",
					"events": [{
						"name": "WizardOnDecision",
						"code": "decisionWizard1();"
					}],
					"nextStages": [{
						"name": "registerNews",
						"route": "registerNews"
					}, {
						"name": "registerEnd",
						"route": "registerEnd"
					}]
				},
				"registerNews": {
					"name": "registerNews",
					"window": "registerNews",
					"events": [{
						"id": 1,
						"name": "WizardOnFinish",
						"code": "wizardOnFinishNews = true;"
					}],
					"nextStages": []
				},
				"registerEnd": {
					"name": "registerEnd",
					"window": "registerEnd",
					"events": [{
						"id": 1,
						"name": "WizardOnFinish",
						"code": "wizardOnFinishEnd = true;"
					}],
					"nextStages": []
				}
			}
		};
	})();

	var wizard2 = (function() {
		return {
			"id": 200,
			"name": "wizardProject",
			"label": "New Project",
			"template": "container/window.html",
			"footer": "component/footer-wizard.html",
			"showHeader": true,
			"showFooter": true,
			"showMenu": true,
			"isVisible": true,
			"currentStageName": "wizardProject",
			"events": [{
				"id": 3,
				"name": "WizardOnCancel",
				"code": ";"
			}],
			"stages": {
				"wizardProject": {
					"name": "wizardProject",
					"window": "wizardProject",
					"events": [{
						"id": 1,
						"name": "WizardBeforeNextStage",
						"code": ";"
					}],
					"nextStages": [{
						"name": "wizardProjectMenu",
						"route": "wizardProjectMenu"
					}]
				},
				"wizardProjectMenu": {
					"name": "wizardProjectMenu",
					"window": "wizardProjectMenu",
					"events": [{
						"id": 5,
						"name": "WizardBeforeNextStage",
						"code": ";"
					}, {
						"id": 6,
						"name": "WizardBeforePreviousStage",
						"code": ";"
					}],
					"nextStages": [{
						"name": "wizardProjectContainers",
						"route": "wizardProjectContainers"
					}]
				},
				"wizardProjectContainers": {
					"name": "wizardProjectContainers",
					"window": "wizardProjectContainers",
					"nextStages": [{
						"route": "wizardProjectCreateConnection",
						"name": "wizardProjectCreateConnection"
					}, {
						"route": "wizardProjectFinish",
						"name": "wizardProjectFinish"
					}],
					"events": [{
							"id": 7,
							"name": "WizardBeforePreviousStage",
							"code": ";"
						}, {
							"id": 33,
							"name": "WizardOnDecision",
							"code": "decisionWizard2();"
						}

					]
				},
				"wizardProjectCreateConnection": {
					"name": "wizardProjectCreateConnection",
					"window": "wizardProjectCreateConnection",
					"events": [{
							"id": 12,
							"name": "WizardOnDecision",
							"code": "decisionWizard3();"
						}, {
							"id": 11,
							"name": "WizardBeforePreviousStage",
							"code": ";"
						}

					],
					"nextStages": [{
						"route": "wizardProjectCreateConnection",
						"name": "wizardProjectCreateConnection"
					}, {
						"route": "wizardProjectQueryRunner",
						"name": "wizardProjectQueryRunner"
					}]
				},
				"wizardProjectQueryRunner": {
					"name": "wizardProjectQueryRunner",
					"window": "wizardProjectQueryRunner",
					"events": [{
							"id": 15,
							"name": "WizardBeforeNextStage",
							"code": ";"
						}, {
							"id": 16,
							"name": "WizardBeforePreviousStage",
							"code": ";"
						}

					],
					"nextStages": [{
						"route": "wizardProjectFinish",
						"name": "wizardProjectFinish"
					}]
				},
				"wizardProjectFinish": {
					"name": "wizardProjectFinish",
					"window": "wizardProjectFinish",
					"events": [{
						"id": 20,
						"name": "WizardOnFinish",
						"code": ";"

					}, {
						"id": 21,
						"name": "WizardBeforePreviousStage",
						"code": ";"
					}],
					"nextStages": []
				}
			}
		};
	})();

	var decisionWizard1 = function() {
		testDecision = true;
		return 'registerNews';
	};
	var decisionWizard2 = function() {
		return 'wizardProjectCreateConnection';
	};
	var decisionWizard3 = function() {
		return 'wizardProjectQueryRunner';
	};

	/*jslint evil: true */
	var eventFactory = new EventFactory(new MethodBuilder({}, {
		$eval: function(a, b) {
			return eval(a, b);
		}
	}), {});
	var eventHandler = new EventHandler({}, {}, console);
	var eventEngine = new EventEngine(eventFactory, eventHandler, {
		updateTemplate: function() {}
	}, {
		i18n: function(text) {
			return text;
		}
	},{logEvent:function() {}});
	var thenable = function(name) {
		return {
			then: function(fn) {
				if (fn) {
					fn({
						name: name
					});
				}
				return thenable(name);
			}
		};
	};
	var renderEngine = {
		changeContainer: function(container) {
			renderEngine.container = container;
		},
		getContainer: thenable
	};
	var templateManager = {
		container: {
			widgets: [{
				currentRow: {}
			}]
		},
		containers: {},
		historyItems: []
	};
	var metadataFactory = new MetaDataFactory(localStorageEngine, requestDataSourceEngine, SQLStorageStrategy, restEngine, eventEngine);

	var jsonContainerLoader = {
		loadContainer: function() {
			return thenable();
		}
	};
	var wizardEngine = new WizardEngine(renderEngine, templateManager, metadataFactory, eventFactory, eventHandler, eventEngine, jsonContainerLoader);

	beforeEach(function() {
		wizardBeforeNextStage = null;
		wizardOnCancel1 = null;
		wizardOnCancel2 = null;
		wizardOnFinishNews = null;
		wizardOnFinishEnd = null;
		testDecision = null;
		wizard1 = metadataFactory.wizardFactory(wizard1);
		wizardEngine.startWizard(wizard1);
	});
	it("Current stage name on start should be registerInit", function() {
		expect(templateManager.wizard.currentStage.name).toBe('registerInit');
	});
	it("Current stage name on first next should be registerAddress", function() {
		wizardEngine.next();
		expect(templateManager.wizard.currentStage.name).toBe('registerAddress');
	});
	it("Current stage name on second next should be registerNews", function() {
		wizardEngine.next();
		wizardEngine.next();
		expect(templateManager.wizard.currentStage.name).toBe('registerNews');
	});
	it("Event WizardBeforeNextStage should be called when next() is called", function() {
		wizardEngine.next();
		expect(wizardBeforeNextStage).toBe(true);
	});
	it("Event WizardOnCancel from wizard should be created and called", function() {
		templateManager.wizard.onCancel();
		expect(templateManager.wizard.onCancel).not.toBe(undefined);
		expect(wizardOnCancel1).toBe(true);
	});
	it("Event WizardOnCancel from the first stage of the wizard should be created and called", function() {
		templateManager.wizard.currentStage.onCancel();
		expect(templateManager.wizard.currentStage.onCancel).not.toBe(undefined);
		expect(wizardOnCancel2).toBe(true);
	});
	it("Event WizardOnDecision from the second stage of the wizard should be created", function() {
		wizardEngine.next();
		expect(templateManager.wizard.currentStage.onDecision).not.toBe(undefined);
	});
	it("Event WizardOnFinish from the third stage of the wizard should be created and called", function() {
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		expect(templateManager.wizard.currentStage.onFinish).not.toBe(undefined);
		expect(wizardOnFinishNews).toBe(true);
	});
	it("Event WizardOnDecision should return 'registerNews'", function() {
		wizardEngine.next();
		var e = templateManager.wizard.currentStage.onDecision();
		expect(testDecision).toBe(true);
		expect(e.data).toBe('registerNews');
	});

	it("Current stage name on second next should be registerEnd when decision return registerEnd", function() {
		decisionWizard1 = function() {
			return 'registerEnd';
		};
		wizardEngine.next();
		wizardEngine.next();

		expect(templateManager.wizard.currentStage.name).toBe('registerEnd');
	});

	it("OnDecision: the wizard must stay in loop and after go to next stage", function() {
		wizard2 = metadataFactory.wizardFactory(wizard2);
		wizardEngine.startWizard(wizard2);

		expect(decisionWizard2()).toBe('wizardProjectCreateConnection');

		decisionWizard3 = function() {
			return 'wizardProjectCreateConnection';
		};

		expect(decisionWizard3()).toBe('wizardProjectCreateConnection');

		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();

		expect(templateManager.wizard.currentStage.name).toBe('wizardProjectCreateConnection');

		wizardEngine.previous();

		expect(templateManager.wizard.currentStage.name).toBe('wizardProjectContainers');

		wizardEngine.next();

		decisionWizard3 = function() {
			return 'wizardProjectQueryRunner';
		};

		wizardEngine.next();

		expect(templateManager.wizard.currentStage.name).toBe('wizardProjectQueryRunner');
	});

	it("OnDecision: the wizard must go to the last stage", function() {
		wizard2 = metadataFactory.wizardFactory(wizard2);
		wizardEngine.startWizard(wizard2);

		decisionWizard2 = function() {
			return 'wizardProjectFinish';
		};
		wizardEngine.next();
		wizardEngine.next();
		wizardEngine.next();

		expect(templateManager.wizard.currentStage.name).toBe('wizardProjectFinish');
	});

});